<?php
namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Geral\Repository\AlteSituacaoFuncionalRepository;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\Util;
use Setforms2\Shared\ORM\DateTime;
use HCM\Util\DateUtil;
use HCM\Geral\Services\ESocialService;
use HCM\FPA\Entity\FpagozoferiasEntity;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Doctrine\DBAL\Connection;
use HCM\Geral\Services\EstruturasService;

class ProgramacaoFeriasService {

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->fpaGozoFerias = new FpagozoferiasEntity($entityManager, $hcmParameters);
    }
    
    public function saveGozoFeriasInline($rows){
        try {
            
            $nrorg = $this->hcmParameters->getNrorgTrabalho(); 
            foreach ($rows as &$row) {    
                $dtinigozoferias = str_replace("/", "", $row["DTINIGOZOFERIAS"]);
                $dtfimgozoferias = str_replace("/", "", $row["DTFIMGOZOFERIAS"]);
                $dataAtual = DateUtil::getDataDeString($this->hcmParameters->getDataAtual());
                
                //Ajusta data inicial de gozo
                $dia = substr($dtinigozoferias, 0, 2);
                $mes = substr($dtinigozoferias, 2, 2) > 0 ? substr($dtinigozoferias, 2, 2) : $dataAtual->format('m');
                $ano = substr($dtinigozoferias, 4, 4) > 0 ? substr($dtinigozoferias, 4, 4) : $dataAtual->format('Y');
                $dataInicioGozo = DateUtil::getDataDeString($dia.'/'.$mes.'/'.$ano, DateUtil::FORMATO_BRASILEIRO, true);
                
                //Ajusta data fim de gozo
                $dia = substr($dtfimgozoferias, 0, 2);
                $mes = substr($dtfimgozoferias, 2, 2) > 0 ? substr($dtfimgozoferias, 2, 2) : $dataAtual->format('m');
                $ano = substr($dtfimgozoferias, 4, 4) > 0 ? substr($dtfimgozoferias, 4, 4) : $dataAtual->format('Y');
                $DataFimGozo = DateUtil::getDataDeString($dia.'/'.$mes.'/'.$ano, DateUtil::FORMATO_BRASILEIRO, true);
                $idAdiant13Sal = $row['IDADIANT13SALAR'] ? $row['IDADIANT13SALAR'] : 'N';
                $dsgozoferias = 'tela de Programacao';
                $dtRetornoFerias = DateUtil::adicionaIntervalo($DataFimGozo, 1);
                
                if($row['NRGOZOFERIAS']){
                    $gozoFerias = $this->fpaGozoFerias->retornaGozoFeriasNrGozo($nrorg, $row['NRGOZOFERIAS']);
                    
                    if($gozoFerias){
                        $gozoFerias->setDtinigozoferias($dataInicioGozo);
                        $gozoFerias->setDtfimgozoferias($DataFimGozo);
                        $gozoFerias->setQtdiasabonoferi($row['QTDIASABONOFERI']);
                        $gozoFerias->setDtretornoferias($dtRetornoFerias);
                        $gozoFerias->setIdadiant13salar($idAdiant13Sal);
                        $gozoFerias->setDsgozoferias($dsgozoferias);
                        $gozoFerias->setDtultatu(DateUtil::getDataAtual());
                        $gozoFerias->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                        $gozoFerias->setCdoperultatu($this->hcmParameters->getCdoperador());
                
                        $this->entityManager->persist($gozoFerias);
                        $this->entityManager->flush($gozoFerias);
                    }
                    
                }else{
                    $this->fpaGozoFerias->incluiGozoFerias($nrorg, $row['NRFERIAS'], $dataInicioGozo, $DataFimGozo, $row['QTDIASABONOFERI'], $dtRetornoFerias, $idAdiant13Sal, $dsgozoferias);
                }
            }
        } catch (Exception $e) {
            throw $e;    
        }
    }
} 