<?php

namespace HCM\Geral\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use HCM\Util\HCMParameters;
use HCM\Geral\Services\ESocialService;
use HCM\Geral\Services\EsoDemonstrativoCustomService;
use HCM\FPA\Services\RelatCustomMovimentacaoService;

class EsoDemonstrativoCustomController extends Crud {
    
    CONST operatorLikeAll = 'LIKE_ALL';
    CONST operatorLike = 'LIKE';
    
    public function __construct (Manager $dataSourceManager, HCMParameters $hcmParameters, EsoDemonstrativoCustomService $esoDemonstrativoCustomService){
        $this->hcmParameters = $hcmParameters;
        $this->esoDemonstrativoCustomService = $esoDemonstrativoCustomService;
        parent::__construct($dataSourceManager);
    }
    
    public function getDemonstrativoESocial(DTO\Request\Filter $request, DTO\Response $response){
        //trazer os dados -> movimentação customizáveis + getS1010
        try {
            set_time_limit(0);
            ini_set('memory_limit', '2048M');
            $filters = \HCM\Util\Util::removerCaracterePorcentagemString($request->getFilterCriteria()->getConditions());
            $parameters = array();
            $fieldsUnset = array('P_DTMESCOMPETENC', 'P_NRORG', 'NRTPMODALIDCAL', 'NROCORRECAL', 'P_NRORG_PADRAO', 'NRTIPOHIERARQORG', 'NRESTRUTGEREN', 'NRTIPOESTRUTURA', 'DADOSVINCULO');
            foreach ($filters as $key => $filter) {
                if (array_search($filter['columnName'], $fieldsUnset) !== false){
                    if($filter['columnName'] === 'NROCORRECAL'){
                        $filter['value'] = str_replace("%", "", $filter['value']);
                    }
                    if($filter['columnName'] === 'DADOSVINCULO'){
                        $filter['value'] = str_replace("%", "", $filter['value']);
                    }
                    unset($filters[$key]);
                }
                if($filter['operator'] == self::operatorLikeAll){
                    $filters[0]['operator'] = self::operatorLike;
                    $filters[0]['columnName'] = str_replace('|', '||', $filter['columnName']);
                }
                $parameters[$filter['columnName']] = $filter['value'];
            }
            $parameters['NROCORRECAL'] = $this->hcmParameters->getOcorrenciaCalculo();
            $parameters['NRTPMODALIDCAL'] = $this->hcmParameters->getNrModalidadeCalculo();
            
            $result = $this->esoDemonstrativoCustomService->getDemonstrativoESocial($parameters, $filters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getDemonstrativoESocial', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}