IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VALIDA_ESTOQUE_DISP_ORE' AND
                 TYPE = 'P' 		            AND
                 U.UID = O.UID               AND
                 U.NAME = USER)

DROP PROCEDURE VALIDA_ESTOQUE_DISP_ORE
GO


CREATE PROCEDURE VALIDA_ESTOQUE_DISP_ORE (@P_FILIAL      VARCHAR(04),
                                          @P_PRODUTO     VARCHAR(10),
                                          @P_NRORCAEVEN  VARCHAR(10),
                                          @P_NRSEQORCA   VARCHAR(02),
                                          @P_DTEVENTO    DATETIME, 
                                          @P_IDORCAENCO  VARCHAR(01),
                                          @P_QTIEMPROD   DOUBLE PRECISION,
                                          @P_CDSUBGRPRODREL VARCHAR(10),
                                          @P_CDGRUPPRODREL  VARCHAR(10),
										  @P_PAIS        VARCHAR(04),
										  @P_ESTADO      VARCHAR(02),
                                          @P_MUNICIPIO   VARCHAR(04),
                                          @P_QTDISP      DOUBLE PRECISION OUTPUT,
                                          @P_VDMENS      VARCHAR(14) OUTPUT)
AS
   DECLARE @V_IDVALEST  VARCHAR(01); 
   DECLARE @V_IDVALESTMAT VARCHAR(30);
   DECLARE @V_ALMOXARIFE VARCHAR(06);
   DECLARE @V_LOCALESTOQ VARCHAR(06);   
   DECLARE @V_QTDESTO  DOUBLE PRECISION;
   DECLARE @V_QTGRUPOESTO DOUBLE PRECISION;
   DECLARE @V_QTITORCAEVE DOUBLE PRECISION;
   DECLARE @V_QTDIASVALANTEVE DOUBLE PRECISION;
   DECLARE @V_QTDIASVALPOSEVE DOUBLE PRECISION;
   DECLARE @V_QTDIASVALANTENT DOUBLE PRECISION;
   DECLARE @V_QTDIASVALPOSENT DOUBLE PRECISION;
   DECLARE @V_DTINICIOORE  DATETIME;
   DECLARE @V_DTFINALORE DATETIME;
   DECLARE @V_QTITORCAENCO DOUBLE PRECISION;
   DECLARE @V_QTDISP DOUBLE PRECISION;
   DECLARE @V_QTTOTAITEM DOUBLE PRECISION;
   DECLARE @V_CDARVPROD VARCHAR(20);
   DECLARE @V_CDPRODESTO VARCHAR(10);
   DECLARE @V_QTDIASANTES DOUBLE PRECISION;
   DECLARE @V_QTDIASAPOS DOUBLE PRECISION;
   DECLARE @V_IDDIASUTEIS VARCHAR(01);
   DECLARE @V_COUNT DOUBLE PRECISION;
   DECLARE @V_IDORCAENCO VARCHAR(01);
   DECLARE @V_QTITMATERIAL DOUBLE PRECISION;
   DECLARE @V_QTEXP DOUBLE PRECISION;
   DECLARE @V_QTSOMA DOUBLE PRECISION;
BEGIN
	SELECT @V_CDARVPROD = CDARVPROD, @V_CDPRODESTO = CDPRODESTO
	  FROM PRODUTO
	 WHERE CDPRODUTO = @P_PRODUTO;
	 
    IF NOT ((@P_PAIS IS NULL) AND (@P_ESTADO IS NULL) AND (@P_MUNICIPIO IS NULL)) BEGIN  
		SELECT @V_QTDIASANTES = ISNULL(SUM(AA.QTDIASANTES), 0),
			 @V_QTDIASAPOS = ISNULL(SUM(AA.QTDIASAPOS), 0)  
		FROM (  SELECT ISNULL(QTDIASANTES, 0) AS QTDIASANTES,
					  ISNULL(QTDIASAPOS, 0)  AS QTDIASAPOS
				 FROM RESPRODORE 
				WHERE CDFILIAL  = @P_FILIAL
				  AND CDPRODUTO = @P_PRODUTO 
			   UNION ALL   
			   SELECT ISNULL(QTDIASANTES, 0) AS QTDIASANTES,
					  ISNULL(QTDIASAPOS, 0)  AS QTDIASAPOS
				FROM RESMUNICORE 
			   WHERE CDFILIAL    = @P_FILIAL
				 AND CDPAIS      = @P_PAIS
				 AND SGESTADO    = @P_ESTADO
				 AND CDMUNICIPIO = @P_MUNICIPIO ) AA; 
	END;
    ELSE BEGIN
		SELECT @V_QTDIASANTES = ISNULL(SUM(AA.QTDIASANTES),0),
			 @V_QTDIASAPOS = ISNULL(SUM(AA.QTDIASAPOS), 0)     
		FROM (  SELECT ISNULL(QTDIASANTES, 0) AS QTDIASANTES,
					 ISNULL(QTDIASAPOS, 0)  AS QTDIASAPOS
			   FROM RESPRODORE 
			  WHERE CDFILIAL  = @P_FILIAL
				AND CDPRODUTO = @P_PRODUTO ) AA;
    END;
	
	SELECT @V_IDDIASUTEIS = ISNULL(IDDIASUTEIS, 'N')
	  FROM RESPRODORE 
	 WHERE CDFILIAL  = @P_FILIAL
	   AND CDPRODUTO = @P_PRODUTO;
	   
    IF @V_IDDIASUTEIS = 'N' BEGIN
        IF NOT ((@P_PAIS IS NULL) AND (@P_ESTADO IS NULL) AND (@P_MUNICIPIO IS NULL)) BEGIN    
			SELECT @V_IDDIASUTEIS = ISNULL(IDDIASUTEIS, 'N')
			  FROM RESMUNICORE 
			 WHERE CDFILIAL    = @P_FILIAL
			   AND CDPAIS      = @P_PAIS
			   AND SGESTADO    = @P_ESTADO
			   AND CDMUNICIPIO = @P_MUNICIPIO;  
        END;
    END;
	
    IF @V_IDDIASUTEIS = 'S' BEGIN
        SET @V_COUNT = 1;
        WHILE @V_COUNT > 0 BEGIN
            SELECT @V_COUNT = COUNT(*)
             FROM FERIFILI
            WHERE CDFILIAL   = @P_FILIAL
              AND CONVERT(FLOAT, DTFERIFILI, 103) = ROUND(CONVERT(FLOAT,@P_DTEVENTO, 103),0,1) + @V_QTDIASAPOS;   
            IF @V_COUNT > 0 BEGIN
              SET @V_QTDIASAPOS = @V_QTDIASAPOS + 1;   
            END;            
        END;
        SET @V_COUNT = 1;
        WHILE @V_COUNT > 0 BEGIN
            SELECT @V_COUNT = COUNT(*)
             FROM FERIFILI
            WHERE CDFILIAL   = @P_FILIAL
              AND CONVERT(FLOAT, DTFERIFILI, 103) = ROUND(CONVERT(FLOAT,@P_DTEVENTO, 103),0,1) - @V_QTDIASANTES;   
            IF @V_COUNT > 0 BEGIN
              SET @V_QTDIASANTES = @V_QTDIASANTES + 1;   
            END;            
        END;
    END;	
	
	IF @P_IDORCAENCO = 'O' BEGIN
		SELECT @V_IDVALEST = MAX(IDVALESTLANOREV),
			 @V_QTDIASVALANTEVE = MAX(QTDIASVALANTEVE),
			 @V_QTDIASVALPOSEVE = MAX(QTDIASVALPOSEVE),
			 @V_QTDIASVALANTENT = MAX(QTDIASVALANTENT),
			 @V_QTDIASVALPOSENT = MAX(QTDIASVALPOSENT)
		FROM PARAMORCAEVE;
		IF @V_QTDIASAPOS > 0 BEGIN
		   SET @V_QTDIASVALPOSEVE = @V_QTDIASAPOS;
		END;
		IF @V_QTDIASANTES > 0 BEGIN
		   SET @V_QTDIASVALANTEVE = @V_QTDIASANTES; 
		END;          

		SELECT @V_QTGRUPOESTO = COUNT(S.CDSUBGRPROD)
		FROM PARAMORCAEVE P, SUBGRUPPROD S
		WHERE P.CDGRPRODRELORCA = S.CDGRUPPROD
		 AND S.CDGRUPPROD = @P_CDGRUPPRODREL
		 AND S.CDSUBGRPROD = @P_CDSUBGRPRODREL
		 AND S.IDVERESTOLANORE = 'S';
	END
	ELSE BEGIN
		IF @P_IDORCAENCO = 'E' BEGIN
			SELECT @V_IDVALEST = MAX(IDVALESTLANENCO), 
				   @V_QTDIASVALANTEVE = MAX(QTDIASVALANTEVE), 
				   @V_QTDIASVALPOSEVE = MAX(QTDIASVALPOSEVE), 
				   @V_QTDIASVALANTENT = MAX(QTDIASVALANTENT), 
				   @V_QTDIASVALPOSENT = MAX(QTDIASVALPOSENT) 
			  FROM PARAMORCAEVE; 
			IF @V_QTDIASAPOS > 0 BEGIN
			   SET @V_QTDIASVALPOSEVE = @V_QTDIASAPOS;
			END;
			IF @V_QTDIASANTES > 0 BEGIN
			   SET @V_QTDIASVALANTEVE = @V_QTDIASANTES; 
			END;  
			SELECT @V_QTGRUPOESTO = COUNT(S.CDSUBGRPROD) 
			  FROM PARAMORCAEVE P, NVSUBGRPROD N, SUBGRUPPROD S, PRODUTO PA 
			 WHERE P.CDGRPRODRELORCA = N.CDGRUPPROD 
			   AND N.CDFILISUBGR = 'P' 
			   AND S.CDGRUPPROD =  N.CDGRUPPROD 
			   AND S.CDSUBGRPROD = N.CDSUBGRPROD 
			   AND N.CDPRODUTO = PA.CDPRODUTO 
			   AND (@V_CDARVPROD BETWEEN PA.CDARVPROD AND PA.CDARVPROD + 'zzzzzzzzzzzzzzzzzzzz');
		END
		ELSE BEGIN
            SELECT @V_IDVALESTMAT = MAX(IDVERESTLANMAT)
              FROM PARAMORCAEVE;
            IF @V_IDVALESTMAT = 'NAOVERIFICA' BEGIN
                SET @V_IDVALEST = 'N';
            END
            ELSE BEGIN
                SET @V_IDVALEST = 'V';
                SET @V_QTGRUPOESTO = 1;                
            END;
            IF @V_QTDIASAPOS > 0 BEGIN 
				SET @V_QTDIASVALPOSEVE = @V_QTDIASAPOS;
			END
            ELSE BEGIN 
				SET @V_QTDIASVALPOSEVE = 0;
			END
            IF @V_QTDIASANTES > 0 BEGIN
				SET @V_QTDIASVALANTEVE = @V_QTDIASANTES;
			END
			ELSE BEGIN
				SET @V_QTDIASVALANTEVE = 0;
			END;   
		END;
	END;
	
   IF (@V_IDVALEST <> 'N') AND (@V_QTGRUPOESTO > 0) BEGIN
		SELECT DISTINCT @V_ALMOXARIFE = CASE PA.IDUTILALMOX WHEN 'S' THEN ISNULL(PF.CDALMOXPRCLI, PA.CDALMOXARIFE) ELSE ' ' END ,
					    @V_LOCALESTOQ = CASE PA.IDUTILLCESTQ WHEN 'S' THEN ISNULL(PF.CDLOCALPRCLI, PA.CDLOCALESTOQ) ELSE ' ' END
		FROM PRODFILI PF, PARAMFILIAL PA, PRODUTO PR
		WHERE PR.CDPRODUTO    = @P_PRODUTO
		 AND PA.CDFILIAL     = @P_FILIAL
		 AND PF.CDPRODUTO    = PR.CDPRODESTO
		 AND PA.CDFILIAL     = PF.CDFILIAL;

		IF  @V_ALMOXARIFE = '' BEGIN
		 SET @V_ALMOXARIFE = NULL;
		END;

		IF  @V_ALMOXARIFE IS NULL BEGIN
		 SET @V_ALMOXARIFE = ' ';
		END;

		IF  @V_LOCALESTOQ = '' BEGIN
		 SET @V_LOCALESTOQ = NULL;
		END;

		IF  @V_LOCALESTOQ IS NULL BEGIN
		 SET @V_LOCALESTOQ = ' ';
		END; 
      
		IF @P_IDORCAENCO = 'O' BEGIN
			SET @V_IDORCAENCO = 'O';
		END
		ELSE BEGIN
			IF @P_IDORCAENCO = 'M' BEGIN
				SET @V_IDORCAENCO = 'O';
			END
			ELSE BEGIN
				IF @P_IDORCAENCO = 'E' BEGIN
					SET @V_IDORCAENCO = 'E';
				END;
			END;            
		END;      
      
		SET @V_QTDESTO = TEKNISA.CONSULTA_ESTOQUE_ORE(@P_FILIAL, @V_CDPRODESTO, @P_IDORCAENCO, @V_ALMOXARIFE, @V_LOCALESTOQ, ' ', ' ');

        --Verifica a quantidade dos oramentos no perodo, diminuindo a quantidade expedida
        SELECT @V_QTSOMA = ISNULL(SUM(IT.QTITEMORCEVE* PR.VRFATOCONV), 0) 
          FROM ITEMORCAEVEN IT, ORCAEVENTO OE, PRODUTO PR 
         WHERE IT.CDFILIAL       = OE.CDFILIAL 
           AND IT.NRORCAEVENTO   = OE.NRORCAEVENTO 
           AND IT.NRSEQORCAEVE   = OE.NRSEQORCAEVE 
           AND OE.CDFILIAL       = @P_FILIAL 
           AND IT.CDPRODUTO      = @P_PRODUTO 
           AND IT.CDPRODUTO      = PR.CDPRODUTO
           AND OE.IDTPORCAEVEN   = 'O' 
           AND CONVERT(FLOAT,@P_DTEVENTO, 103) 
				BETWEEN (ROUND(CONVERT(FLOAT,OE.DTEVENTO, 103),0,1) - ISNULL(@V_QTDIASVALANTEVE, 0)) 
				    AND (ROUND(CONVERT(FLOAT,OE.DTEVENTO, 103),0,1) + ISNULL(@V_QTDIASVALPOSEVE, 0)) 
           AND NOT OE.IDSITUORCEVE  IN ('1','7','8','9')
           AND NOT EXISTS (SELECT NF.IDORIGNFORCA
                             FROM NFRELACORC NF
                            WHERE NF.IDORIGNFORCA = 'E'
                              AND NF.CDFILIAL     = OE.CDFILIAL
                              AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
                              AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE);
         
        IF @V_QTSOMA > 0 BEGIN 
            SELECT @V_QTEXP = ISNULL(SUM(QTEXPITEMPED), 0) 
              FROM ITEMPEDIDO
             WHERE IDSITITEMPED IN ('4', '7')
               AND NRPEDIDO IN 
			   (SELECT NRPEDIDO 
				  FROM PEDIDO
				 WHERE CDFILIAL     = @P_FILIAL
				   AND NRORCAEVENTO IN 
				   (SELECT OE.NRORCAEVENTO
					  FROM ITEMORCAEVEN IT, ORCAEVENTO OE, PRODUTO PR 
					 WHERE IT.CDFILIAL       = OE.CDFILIAL 
					   AND IT.NRORCAEVENTO   = OE.NRORCAEVENTO 
					   AND IT.NRSEQORCAEVE   = OE.NRSEQORCAEVE 
					   AND OE.CDFILIAL       = @P_FILIAL 
					   AND IT.CDPRODUTO      = @P_PRODUTO 
					   AND IT.CDPRODUTO      = PR.CDPRODUTO
					   AND OE.IDTPORCAEVEN   = 'O' 
					   AND CONVERT(FLOAT,@P_DTEVENTO, 103) 
							BETWEEN (ROUND(CONVERT(FLOAT,OE.DTEVENTO, 103),0,1) - ISNULL(@V_QTDIASVALANTEVE, 0))
								AND (ROUND(CONVERT(FLOAT,OE.DTEVENTO, 103),0,1) + ISNULL(@V_QTDIASVALPOSEVE, 0)) 
					   AND NOT EXISTS (SELECT NF.IDORIGNFORCA
										 FROM NFRELACORC NF
										WHERE NF.IDORIGNFORCA = 'E'
										  AND NF.CDFILIAL     = OE.CDFILIAL
										  AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
										  AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE)
				   )
				   AND IDORIGPED    IN ('4', '5')
			   );
            
            SET @V_QTITORCAEVE = @V_QTSOMA - @V_QTEXP;                               
        END;        
        
        --Verifica a quantidade das encomendas no perodo, diminuindo a quantidade expedida
        SELECT @V_QTSOMA = ISNULL(SUM(IT.QTITEMORCEVE* PR.VRFATOCONV), 0) 
          FROM ITEMORCAEVEN IT, ORCAEVENTO OE, PRODUTO PR 
         WHERE IT.CDFILIAL       = OE.CDFILIAL 
           AND IT.NRORCAEVENTO   = OE.NRORCAEVENTO 
           AND IT.NRSEQORCAEVE   = OE.NRSEQORCAEVE 
           AND OE.CDFILIAL       = @P_FILIAL 
           AND IT.CDPRODUTO      = @P_PRODUTO 
           AND PR.CDPRODUTO      = IT.CDPRODUTO
           AND OE.IDTPORCAEVEN   = 'E' 
           AND CONVERT(FLOAT,@P_DTEVENTO, 103) 
				BETWEEN (ROUND(CONVERT(FLOAT,OE.DTHRENTROREV,103),0,1) - ISNULL(@V_QTDIASVALANTENT, 0)) 
			        AND (ROUND(CONVERT(FLOAT,OE.DTHRENTROREV,103),0,1) + ISNULL(@V_QTDIASVALPOSENT, 0)) 
           AND NOT OE.IDSITUORCEVE IN ('1', '7')
           AND NOT EXISTS (SELECT NF.IDORIGNFORCA
                             FROM NFRELACORC NF
                            WHERE NF.IDORIGNFORCA = 'E'
                              AND NF.CDFILIAL     = OE.CDFILIAL
                              AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
                              AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE);           
        
        IF @V_QTSOMA > 0 BEGIN
            SELECT @V_QTEXP = ISNULL(SUM(QTEXPITEMPED), 0) 
              FROM ITEMPEDIDO
             WHERE IDSITITEMPED IN ('4', '7')
               AND NRPEDIDO IN 
			   (SELECT NRPEDIDO 
				  FROM PEDIDO
				 WHERE CDFILIAL     = @P_FILIAL
				   AND NRORCAEVENTO IN 
				   (SELECT OE.NRORCAEVENTO
					  FROM ITEMORCAEVEN IT, ORCAEVENTO OE, PRODUTO PR 
					 WHERE IT.CDFILIAL       = OE.CDFILIAL 
					   AND IT.NRORCAEVENTO   = OE.NRORCAEVENTO 
					   AND IT.NRSEQORCAEVE   = OE.NRSEQORCAEVE 
					   AND OE.CDFILIAL       = @P_FILIAL 
					   AND IT.CDPRODUTO      = @P_PRODUTO 
					   AND IT.CDPRODUTO      = PR.CDPRODUTO
					   AND OE.IDTPORCAEVEN   = 'E' 
					   AND CONVERT(FLOAT,@P_DTEVENTO,103) 
							BETWEEN (ROUND(CONVERT(FLOAT,OE.DTHRENTROREV,103),0,1) - ISNULL(@V_QTDIASVALANTENT, 0))
								AND (ROUND(CONVERT(FLOAT,OE.DTHRENTROREV,103),0,1) + ISNULL(@V_QTDIASVALPOSENT, 0)) 
					   AND NOT EXISTS (SELECT NF.IDORIGNFORCA
										 FROM NFRELACORC NF
										WHERE NF.IDORIGNFORCA = 'E'
										  AND NF.CDFILIAL     = OE.CDFILIAL
										  AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
										  AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE)                                                           
				   )
				   AND IDORIGPED    = '7'
			   );     
            
            SET @V_QTITORCAENCO = @V_QTSOMA - @V_QTEXP;  
        END; 
        
        --Verifica a quantidade de materiais no perodo, diminuindo a quantidade expedida
        SELECT @V_QTSOMA = ISNULL(SUM(IT.QTITEMPED * PR.VRFATOCONV), 0)
          FROM PEDIDO PE, ORCAEVENTO OE, ITEMPEDIDO IT, PRODUTO PR
         WHERE PE.CDFILIAL       = OE.CDFILIAL
           AND PE.NRORCAEVENTO   = OE.NRORCAEVENTO
           AND PE.CDFILIAL       = IT.CDFILIAL
           AND PE.NRPEDIDO       = IT.NRPEDIDO
           AND IT.CDPRODUTO      = @P_PRODUTO
           AND IT.CDPRODUTO      = PR.CDPRODUTO
           AND OE.IDTPORCAEVEN   = 'O'
           AND PE.IDORIGPED      = '8'
           AND OE.NRORCAEVENTO  <> @P_NRORCAEVEN
           AND OE.NRSEQORCAEVE  <> @P_NRSEQORCA
           AND CONVERT(FLOAT,@P_DTEVENTO,103) 
				BETWEEN (ROUND(CONVERT(FLOAT,OE.DTEVENTO,103),0,1) - ISNULL(@V_QTDIASVALANTEVE, 0)) 
			        AND (ROUND(CONVERT(FLOAT,OE.DTEVENTO,103),0,1) + ISNULL(@V_QTDIASVALPOSEVE, 0))
           AND NOT EXISTS (SELECT NF.IDORIGNFORCA
                             FROM NFRELACORC NF
                            WHERE NF.IDORIGNFORCA = 'E'
                              AND NF.CDFILIAL     = OE.CDFILIAL
                              AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
                              AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE);           
        
        IF @V_QTSOMA > 0 BEGIN
            SELECT @V_QTEXP = ISNULL(SUM(QTEXPITEMPED), 0) 
              FROM ITEMPEDIDO
             WHERE IDSITITEMPED IN ('4', '7')
               AND NRPEDIDO IN 
			   (SELECT NRPEDIDO 
				  FROM PEDIDO
				 WHERE CDFILIAL     = @P_FILIAL
				   AND NRORCAEVENTO IN 
				   (SELECT OE.NRORCAEVENTO
					  FROM PEDIDO PE, ORCAEVENTO OE, ITEMPEDIDO IT, PRODUTO PR
					 WHERE PE.CDFILIAL       = OE.CDFILIAL
					   AND PE.NRORCAEVENTO   = OE.NRORCAEVENTO
					   AND PE.CDFILIAL       = IT.CDFILIAL
					   AND PE.NRPEDIDO       = IT.NRPEDIDO
					   AND IT.CDPRODUTO      = @P_PRODUTO
					   AND IT.CDPRODUTO      = PR.CDPRODUTO
					   AND OE.IDTPORCAEVEN   = 'O'
					   AND PE.IDORIGPED      = '8'
					   AND CONVERT(FLOAT,@P_DTEVENTO,103) 
							BETWEEN (ROUND(CONVERT(FLOAT,OE.DTEVENTO,103),0,1) - ISNULL(@V_QTDIASVALANTEVE, 0)) 
								AND (ROUND(CONVERT(FLOAT,OE.DTEVENTO,103),0,1) + ISNULL(@V_QTDIASVALPOSEVE, 0))
					   AND NOT EXISTS (SELECT NF.IDORIGNFORCA
										 FROM NFRELACORC NF
										WHERE NF.IDORIGNFORCA = 'E'
										  AND NF.CDFILIAL     = OE.CDFILIAL
										  AND NF.NRORCAEVENTO = OE.NRORCAEVENTO
										  AND NF.NRSEQORCAEVE = OE.NRSEQORCAEVE)                                                           
				   )
				   AND IDORIGPED    = '8'
			   );        
            SET @V_QTITMATERIAL = @V_QTSOMA - @V_QTEXP;
        END;

		SET @P_QTDISP = ISNULL(@V_QTDESTO, 0) - ISNULL(@V_QTITORCAEVE, 0) - ISNULL(@V_QTITORCAENCO, 0) - ISNULL(@P_QTIEMPROD, 0) - ISNULL(@V_QTTOTAITEM, 0);

		IF @V_IDVALEST = 'B' BEGIN
			SET @P_VDMENS = 'MENS_BLOQ';
		END
		ELSE BEGIN
			SET @P_VDMENS = 'MENS_AVISO';
		END;
   END
   ELSE BEGIN
      SET @P_QTDISP = 0;
      SET @P_VDMENS = 'NAO_VERIFICADO';
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALIDA_ESTOQUE_DISP_ORE','0.00.000';
GO
